/** This file is part of Domotz Agent.
  * Copyright (C) 2016  Domotz Ltd
  *
  * Domotz Agent is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * Domotz Agent is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
  **/
/**
 *
 * Created by Iacopo Papalini <ipapalini@domotz.com> on 13/05/15.
 */

var factory = function(handler, resourceLocator) {
    var myConsole = resourceLocator.log.decorateLogs();
    var configuration = resourceLocator.configuration;

    var callQueue = configuration.message_broker.call_queue;
    var exchange = configuration.message_broker.exchange || '';
    var amqpOptions = {noAck: false};

    return {
        consume: function (channel) {
            myConsole.info('Listening on queue ' + callQueue);
            return channel.consume(callQueue, function (msg) {
                try {
                    handler.processMessage(channel, exchange, msg);
                    channel.ack(msg);
                } catch (err) {
                    myConsole.warn(err.message);
                    myConsole.warn(err.stack);
                    channel.nack(msg);
                }
            }, amqpOptions).then(null, myConsole.warn);
        }
    };

};

module.exports.factory = factory;
