/** This file is part of Domotz Agent.
 * Copyright (C) 2021  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Alessandro Pagiaro <a.pagiaro@domotz.com> on 06/07/2021.
 */


var factory = function (host, registerRequest) {

    function create(ipAddress, listeningPort) {
        var body = {
            private_ip: ipAddress,
            port: listeningPort
        };
        return registerRequest.sendWithPromise('not-configured-agent/' + host.getMAC() + '/activation-token', 'POST', body);
    }

    function getActivationUrl(token) {
        return registerRequest.sendWithPromise('agent/activation-token/' + token + '/activation-url', 'GET');
    }

    return {
        create: create,
        getActivationUrl: getActivationUrl
    };
};

module.exports.factory = factory;

