/** This file is part of Domotz Agent.
 * Copyright (C) 2021  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Created by Andrea Azzara <a.azzara@domotz.com> on 7/09/2021.
 */


var agentRestart = function (message, resourceLocator) {
    return {
        describe: function () {
            return 'Agent Restart';
        },
        execute: function (callback) {

            var delay = resourceLocator.lodash.get(message, 'payload.delay_ms', 2000);
            setTimeout(resourceLocator.utils.proc.gracefulShutdown, delay);
            callback();
        }
    };
};

module.exports.command = agentRestart;