/** 
 * This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

var newDevice = function (message, resourceLocator) {
    var myConsole = resourceLocator.log.decorateLogs();
    var payload = message.payload;

    var deviceId = payload.device_id;
    var mac = payload.mac;
    var ipAddress = payload.ip_address;
    return {
        execute: function (callback) {
            myConsole.info("Executing newDevice command device id %s mac %s ip %s", deviceId, mac, JSON.stringify(ipAddress));
            resourceLocator.discovery.protocols_orchestrator.addDevice(deviceId, mac, ipAddress);
            if (ipAddress.length > 0) {
                var mainIpAddress = ipAddress[0];
                resourceLocator.discovery.snmp_check_status_discovery.discover(mainIpAddress, mac);
            }
            callback({});
        },
        describe: function () {
            return "newDevice message: " + JSON.stringify(payload);
        }
    };
};

module.exports.command = newDevice;
