/**
 * This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Created by Iacopo Papalini <iacopo@domotz.com> on 02/08/2017.
 */

var ping = function (message, resourceLocator) {
    var ip = message.payload.ip;
    var count = message.payload.count;
    var timeout = message.payload.timeout;
    var networkManager = resourceLocator.networkTools.networkManager;

    return {
        execute: function (callback) {
            return networkManager.ping(ip, count, timeout).then(callback).catch(callback);
        },
        describe: function () {
            return message.correlationId + " - Ping host: " + ip;
        }
    };
};


module.exports.command = ping;