/** This file is part of Domotz Agent.
 * Copyright (C) 2020  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Fausto Lelli <fausto@domotz.com> on 24/06/2021.
 */

var performOverlayDeviceDBInvalidate = function (message, resourceLocator) {

    var logger = resourceLocator.log.decorateLogs();

    return {

        describe: function () {
            return message.correlationId + " - OVERLAY_DEVICE_DB_INVALIDATE - ";
        },
        execute: function (callback) {
            logger.info('SNMP Overlay DB Invalidate: Received NETWORK/SNMP/OVERLAY_DEVICE_DB_INVALIDATE command');
            resourceLocator.discovery.snmp_overlay_device_db.invalidate();
            callback();
        }
    };
};

module.exports.command = performOverlayDeviceDBInvalidate;
