/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz UK LLP
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Alessio Sanfratello <asanfratello@domotz.com> on 13/02/17.
 *
 */

var snmpUpdateCustomInfo = function (message, resourceLocator) {
    "use strict";

     var myConsole = resourceLocator.log.decorateLogs();
    var forceSnmpCustomDiscovery = require('../../../events/handler/snmpCustomDiscovery').discoveryForcing;

    return {
        describe: function () {
            return "Start SNMP information gathering (custom)";
        },
        execute: function () {
            myConsole.info('SNMP Custom Discovery:: Received NETWORK/SNMP/UPDATE_CUSTOM_INFO command');
            forceSnmpCustomDiscovery(resourceLocator);
        }
    };
};

module.exports.command = snmpUpdateCustomInfo;
