/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz UK LLP
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Massimiliano Cuzzoli <massi@domotz.com> on 19/12/16.
 *
 */


const SNMP_BASIC_DISCOVERY_DELAY = 2 * 1000;
const SNMP_INTERFACE_DISCOVERY_DELAY = 2 * 60 * 1000;
const SNMP_CUSTOM_DISCOVERY_DELAY = 60 * 1000;

// TODO: move to resourceHandler
var discoveryHandlers = {
    forceSnmpBasicDiscovery: require('../../../events/handler/snmpBasicDiscovery').discoveryForcing,
    forceSnmpInterfaceDiscovery: require('../../../events/handler/snmpInterfaceDiscovery').discoveryForcing,
    forceSnmpCustomDiscovery: require('../../../events/handler/snmpCustomDiscovery').discoveryForcing
};


var snmpUpdateInfo = function (message, resourceLocator) {
    "use strict";
    // var snmpCustomDiscovery = resourceLocator.discovery.snmp_custom_discovery;

    return {
        describe: function () {
            return "Start SNMP information gathering (basic + interfaces)";
        },
        execute: function () {
            resourceLocator.snmpCommunitiesProvider.invalidate();
            setTimeout(discoveryHandlers.forceSnmpBasicDiscovery, SNMP_BASIC_DISCOVERY_DELAY);
            setTimeout(discoveryHandlers.forceSnmpInterfaceDiscovery, SNMP_INTERFACE_DISCOVERY_DELAY);
            setTimeout(function () {
                discoveryHandlers.forceSnmpCustomDiscovery(resourceLocator);
            }, SNMP_CUSTOM_DISCOVERY_DELAY);

        }
    };
};

module.exports.command = snmpUpdateInfo;
