/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Invalidates the list of the TCP Services to be monotired, usually after the
 * user changed it from app
 *
 * Created by Iacopo Papalini <iacopo@domotz.com> on 26/10/16.
 */


var updateList = function (message, resourceLocator) {
     var myConsole = resourceLocator.log.decorateLogs();
    "use strict";
    return {
        describe: function () {
            return message.correlationId + " - invalidate TCP Monitored services list ";
        },
        execute: function () {
            resourceLocator.discovery.tcp_services_monitoring.invalidateList();
            myConsole.info("COMMAND - (tcpServicesMonitoring): Force TCP services scan");
            resourceLocator.discovery.tcp_services_monitoring.monitor();
        }
    };
};

module.exports.command = updateList;