/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

/**
 * Created by Georgi Tsatsev <gtsatsev@domotz.com> on 16/08/17.
 */


var sshBulkSend = function (message, resourceLocator) {
    var sshSendFactory = resourceLocator.sshSendFactory;
    return {
        describe: function () {
            return sshSendFactory.logCommand(message);
        },
        execute: function (callback) {
            var payload = message.payload;
            sshSendFactory.logCommand(message);
            sshSendFactory.sshBulkSend(payload).then(function (result) {
                callback(JSON.stringify(result));
            }).catch(function (result) {
                callback({error: result.message});
            });
        }
    };
};

module.exports.command = sshBulkSend;