/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 * Created by Iacopo Papalini <ipapalini@domotz.com> on 09/04/15.
 *
 */

var udpListen = function (message, resourceLocator) {

    var listener = resourceLocator.udp.listener;
    var udpUtils = resourceLocator.udp.utils;

    var payload = message.payload;
    var host = payload.host;
    var port = payload.port;
    var reportTo = payload.report_to;
    var datagramFilters = payload.datagram_filters || [];

    return {
        describe: function () {
            return message.correlationId + " - udpListen - " + host +
                ':' + port + ' - ' + reportTo;
        },
        execute: function (callback) {
            var tmp = [];

            for (var i = 0; i < datagramFilters.length; i++) {
                tmp[i] = udpUtils.decode(datagramFilters[i]);
            }

            listener.register(host, port, reportTo, tmp);
            callback();
        }
    };
};

module.exports.command = udpListen;