/** This file is part of Domotz Agent.
 * Copyright (C) 2017  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Sends a Wake on Lan magic packet to the specified MAC address
 *
 * Created by Alessio Sanfratello <asanfratello@domotz.com> on 27/01/2017.
 */


var updateSettings = function (message, resourceLocator) {
    var myConsole = resourceLocator.log.decorateLogs();

    return {
        describe: function () {
            return "Update Settings";
        },
        execute: function (callback) {
            myConsole.info('received UPDATE_SETTINGS command' + resourceLocator.event.toString());
            resourceLocator.settingsManager.fetchSettings(true);
            callback();
        }
    };
};

module.exports.command = updateSettings;