/** This file is part of Domotz Agent.
  * Copyright (C) 2016  Domotz Ltd
  *
  * Domotz Agent is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * Domotz Agent is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
  **/
/**
 * Created by Iacopo Papalini <ipapalini@domotz.com> on 09/04/15.
 *
 */

var upnpSubscribe = function (message, resourceLocator) {

    var subscriptionsManager = resourceLocator.upnp.subscriptionsManager;

    var payload = message.payload;

    return {
        describe: function () {
            return message.correlationId + " - upnpSubscribe - " +
                payload.host + ':' + payload.port + payload.path + ' ' +
                '(' + JSON.stringify(payload.properties) + ')' +
                ' - ' + payload.report_to;
        },
        execute: function (callback) {
            subscriptionsManager.subscribe(payload, message.correlationId);
            callback();
        }
    };
};

module.exports.command = upnpSubscribe;