/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

function getFirstIpv4Address(input) {
    for (var i = 0; i < input.addresses.length; i++) {
        var address = input.addresses[i];
        if (/^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/.test(address)) {
            return address;
        }
    }
    var referer = input.referer || {};
    if (referer.family === 'IPv4') {
        return referer.address;
    }
    return null;
}

module.exports.parse = function (input, service) {
    var ipv4address = getFirstIpv4Address(input);
    if (!ipv4address) {
        return null;
    }

    return {
        "ip": ipv4address,
        "name": input.name,
        "txt": input.txt,
        "host": input.host,
        "fqdn": input.fqdn,
        "service": service
    };
};

