/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

/**
 * Created by Andrea Azzarà <a.azzara@domotz.com> on 19/08/19.
 *
 */

function discoveryCounter (configuration, settingsManager) {
    var counter = 0;

    var discovery = configuration.discovery;

    var fullDiscoveryPeriod = discovery && discovery.refresh ? discovery.refresh : 30;

    function getNextSequenceNumber () {
        if (settingsManager.isLowThrottleMode()) {
            return 0;
        }
        return counter % fullDiscoveryPeriod ? counter : 0;
    }

    function isFullDiscovery () {
        return getNextSequenceNumber() === 0;
    }

    function incrementCounter () {
        counter++;
    }

    return {
        getNextSequenceNumber: getNextSequenceNumber,
        isFullDiscovery: isFullDiscovery,
        incrementCounter: incrementCounter
    };
}


module.exports.discoveryCounter = discoveryCounter;