/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz UK LLP
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Memory persistence of the mac<->number of snmp interfaces
 *
 * Created by Iacopo Papalini <iacopo@domotz.com> on 12/09/2017.
 */

var snmpInterfaces = {};

module.exports.storage = {
    store: function (mac, count) {
        "use strict";
        snmpInterfaces[mac] = count;
    },
    fetch: function(mac) {
        "use strict";
        return snmpInterfaces[mac] || 0;
    }
};