/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz UK LLP
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Massimiliano Cuzzoli <massi@domotz.com> on 26/08/16.
 *
 */

const XML_PARSING_ERROR_LEVEL = 'XML_PARSING_ERROR';


var responseParserFactory = function(resourceLocator, messageBuilder) {
    var q = resourceLocator.q;
    var xml2js = resourceLocator.xml2js;

    return {
        parse_xml_response: function(body) {
            var deferred = q.defer();

            xml2js.parseString(body, function (err, result) {
                if (err) {
                    deferred.reject(messageBuilder.buildErrorMessage(XML_PARSING_ERROR_LEVEL, null, err));
                } else {
                    deferred.resolve(messageBuilder.buildSuccessMessage(result));
                }
            });
            return deferred.promise;
        }
    };
};

module.exports.factory = responseParserFactory;
