/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

var counter = 18;
var numberOfFastDiscoveryCycle = 20;

var igdDiscovery = function(resourceLocator) {
    var myConsole = resourceLocator.log.decorateLogs();

    counter++;
    myConsole.info('called: ' + counter + ' times, starting at ' + numberOfFastDiscoveryCycle + ' )');

    if (counter === numberOfFastDiscoveryCycle) {
        counter = 0;

        var settings = resourceLocator.configuration.settings;
        var enabled = settings !== undefined && settings.upnp_igd_scanner === true;
        if (!enabled) {
            myConsole.info('automated discovery is disabled');
            return;
        }

        myConsole.info('performing discovery');

        resourceLocator.discovery.upnp_igd_discovery.discover();
    }
};

module.exports.handler = igdDiscovery;
