/** This file is part of Domotz Agent.
 * Copyright (C) 2021 Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *
 * Created by fausto@domotz.com on 28/04/2021.
 *
 */

var counter = 4;
var numberOfFastDiscoveryCycle = 8;
var forceDiscover = false;

var snmpCheckStatusDiscovery = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();
    var enabled = resourceLocator.settingsManager.isSnmpCheckStatusDiscoveryEnabled();

    logger.info(' enabled %s forced %s counter => %s / %s ', enabled, forceDiscover, counter, numberOfFastDiscoveryCycle);
    if (forceDiscover || counter === numberOfFastDiscoveryCycle && enabled) {
        if (counter === numberOfFastDiscoveryCycle) {
            counter = 0;
        }
        forceDiscover = false;
        resourceLocator.discovery.snmp_check_status_discovery.discoverAll();
    }
    counter++;
};


var discoveryForcing = function () {
    forceDiscover = true;
};


module.exports.handler = snmpCheckStatusDiscovery;
module.exports.discoveryForcing = discoveryForcing;