/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Alessio Sanfratello <asanfratello@domotz.com> on 09/02/17.
 */


var counter = 16;

var performDiscovery = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();
    var snmpCustomDiscovery = resourceLocator.discovery.snmp_custom_discovery;
    logger.debug('Performing SNMP custom discovery');

    snmpCustomDiscovery.discover(
        snmpCustomDiscovery.sendDiscoveryDataToEngine, undefined).then(function (lockStatus) {
        "use strict";
        logger.info('Lock status found: ' + lockStatus);
    });
};

var snmpCustomDiscovery = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();

    var numberOfFastDiscoveryCycle = resourceLocator.settingsManager.getEyesInterval();
    var enabled = resourceLocator.settingsManager.isSnmpCustomDiscoveryEnabled();

    if (!numberOfFastDiscoveryCycle) {
        return;
    }
    logger.info(' enabled %s  counter => %s / %s', enabled, counter, numberOfFastDiscoveryCycle);

    if (counter === 0 && enabled) {
        performDiscovery(resourceLocator);
    }

    counter = (counter + 1) % numberOfFastDiscoveryCycle;
};

var discoveryForcing = function (resourceLocator) {
    resourceLocator.discovery.snmp_custom_discovery.invalidate();
    performDiscovery(resourceLocator);
};

module.exports.handler = snmpCustomDiscovery;
module.exports.discoveryForcing = discoveryForcing;
