/** This file is part of Domotz Agent.
 * Copyright (C) 2020  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Fausto Lelli <fausto@domotz.com> 
 */

var counter = 1;
var isStartup = true;

var snmpOverlayDB = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();
    var numberOfFastDiscoveryCycle = null;

    var nonStartupNumberOfFastDiscoveryCycle = resourceLocator.settingsManager.getOverlayDBInterval();
    var startupNumberOfFastDiscoveryCycle = resourceLocator.settingsManager.getOverlayDBStartupInterval();

    if(isStartup) {
        numberOfFastDiscoveryCycle = startupNumberOfFastDiscoveryCycle;
    } else{
        numberOfFastDiscoveryCycle = nonStartupNumberOfFastDiscoveryCycle;
    }

    if (!numberOfFastDiscoveryCycle) {
        logger.info('avoiding snmp overlay db by settings value %s ', numberOfFastDiscoveryCycle);
        return;
    }

    logger.info('     counter => %s / %s ', counter, numberOfFastDiscoveryCycle);

    if (counter === 0) {
        logger.info('Performing SNMP Overlay DB check');
        resourceLocator.discovery.snmp_overlay_db.checkOverlayDB();
        isStartup = false;
    }
    counter++;
    if (counter >= numberOfFastDiscoveryCycle) {
        counter = 0;
    }

};

module.exports.handler = snmpOverlayDB;
