/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Created by Fausto Lelli <fausto@domotz.com> 
 */

var counter = 6;
var forceDiscover = false;

var performDiscovery = function (resourceLocator) {
    var snmpOverlayDiscoveryProcessor = resourceLocator.discovery.snmp_overlay_discovery;
    snmpOverlayDiscoveryProcessor.discover();
};

var snmpOverlayDiscovery = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();
    var enabled = resourceLocator.settingsManager.isSnmpOverlayDiscoveryEnabled();
    var numberOfFastDiscoveryCycle = resourceLocator.settingsManager.getEyesInterval();

    if (!numberOfFastDiscoveryCycle) {
        return;
    }

    logger.info(' enabled %s  counter => %s / %s  forcing %s', enabled, counter, numberOfFastDiscoveryCycle, forceDiscover);

    if ((counter === 0 || forceDiscover) && enabled) {
        logger.info('Performing SNMP overlay discovery');
        forceDiscover = false;
        performDiscovery(resourceLocator);
    }

    counter = (counter + 1) % numberOfFastDiscoveryCycle;
};

var forceNextDiscovery = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();
    logger.info('Forcing next discovery');
    forceDiscover = true;
};

module.exports.handler = snmpOverlayDiscovery;
module.exports.forceNextDiscovery = forceNextDiscovery;
