/** This file is part of Domotz Agent.
 * Copyright (C) 2021 Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by a.lulli@domotz.com on 28/04/2021.
 */

var counter = 58;
var numberOfFastDiscoveryCycle = 60;

var handler = function (resourceLocator) {
    var logger = resourceLocator.log.decorateLogs();

    logger.info('counter => %s / %s', counter, numberOfFastDiscoveryCycle);
    var udpPorts = resourceLocator.settingsManager.getDiscoverySettings().udp_ports;

    if (counter === 0 && udpPorts && udpPorts.length > 0) {
        logger.debug('Performing UDP port scan');
        resourceLocator.discovery.udp_port.udpPortScan();
    }

    counter = (counter + 1) % numberOfFastDiscoveryCycle;
};

module.exports.handler = handler;
