/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Created by Iacopo Papalini <iacopo@domotz.com> on 27/02/2017.
 */

module.exports.post = function (resourceLocator) {

    var eventHandler = resourceLocator.event;
    var log = resourceLocator.log;
    var myConsole = log.decorateLogs();


    return function (req, res) {
        var eventName = req.params.event_name;
        if (!resourceLocator.status.isPassive()) {
            myConsole.warn('Attempt to trigger event %s in %s mode', eventName, resourceLocator.status.get());
            res.status(403).send('Forbidden');
            return;
        }

        myConsole.info('Manually triggering event %s', eventName);
        eventHandler[eventName](resourceLocator);
        res.json();
    };
};