/** This file is part of Domotz Agent.
  * Copyright (C) 2016  Domotz Ltd
  *
  * Domotz Agent is free software: you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * Domotz Agent is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
  **/
/**
 *
 * Created by Iacopo Papalini <ipapalini@domotz.com> on 10/09/15.
 */


module.exports.get = function (resourceLocator, onException, onSuccess) {
    return function (req, res) {
        var message = {payload: {server_id: req.query['server-id'].trim()}};
        if (!message.payload.server_id) {
            onException(res, {status: 400, message: 'BAD REQUEST, missing server id'});
            return;
        }
        console.info('API - (%s): %s', req.method, req.url);
        var command = require('../../../commands/network/speedTest').command(message, resourceLocator);
        command.describe();
        command.execute(require('../helpers').commandToWeb(onException, onSuccess, res));
    };
}
;