/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/
/**
 *
 * Created by Andrea Azzarà <a.azzara@domotz.com> on 10/01/17.
 */

var mod = require('../../../commands/network/ping');

module.exports.post = function (resourceLocator, onException, onSuccess) {
    var helpers = require('../helpers');
    var neededParameters = ['ip', 'count', 'timeout'];
    /*
     * Pings an host
     * Required JSON attributes in request body (type string): ip, count, timeout
     * */
    return function (req, res) {
        var payload = req.body;
        console.info('API - (%s): %s', req.method, req.url);

        if (!helpers.checkParameters(payload, neededParameters, res, onException)) {
            return;
        }

        var command = mod.command({payload: payload}, resourceLocator);
        command.execute(helpers.commandToWeb(onException, onSuccess, res));
    };
};
