/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Created by Iacopo Papalini <iacopo@domotz.com>.
 */

module.exports.post = function (resourceLocator, onException, onSuccess) {
    return function (req, res) {
        console.info('SANDBOX API - (%s): %s', req.method, req.url);
        var data = req.body;

        function success(result) {
            console.info("SANDBOX On success");
            delete result.myLog;
            return onSuccess(res, result);
        }

        function failure(result) {
            console.warn("SANDBOX Failure: %s", JSON.stringify(result));
            delete result.myLog;
            return onSuccess(res, result);
        }

        resourceLocator.sandboxRunner(data, failure, success);
    };

};
