var jamStateManager = function () {
    var disappearedMacAddresses = [];
    var appearedMacAddresses = [];

    var updateBlockingFeatureState = function (blockedMacAddresses, macAddressesToBlock) {
        disappearedMacAddresses = blockedMacAddresses.filter(function (i) {
            return macAddressesToBlock.indexOf(i) < 0;
        });
        appearedMacAddresses = macAddressesToBlock.filter(function (i) {
            return blockedMacAddresses.indexOf(i) < 0;
        });

        return disappearedMacAddresses.length > 0 || appearedMacAddresses.length > 0;
    };

    return {
        update: updateBlockingFeatureState,
        getMacAddressesToUnblock: function () {
            return disappearedMacAddresses;
        },
        getMacAddressesToBlock: function () {
            return appearedMacAddresses;
        }
    };
};

module.exports = jamStateManager;