/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz Ltd
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Created by Iacopo Papalini <ipapalini@domotz.com> on 09/04/15.
 *
 */
const MODULE = 'SCHEDULER';

function nop() {}

function execute(schedule) {
    if (schedule.length === 0) {
        return;
    }
    var item = schedule.shift();
    console.info("%s: Executing schedule item '%s' %d remaining - new item in %s ms",
        MODULE, item[2], schedule.length, item[1]);
    item[0]();
    setTimeout(function () {
        execute(schedule);
    }, item[1]);
}

module.exports.execute = execute;
module.exports.nop = nop;