/** This file is part of Domotz Agent.
 * Copyright (C) 2016  Domotz UK LLP
 *
 * Domotz Agent is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Domotz Agent is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Domotz Agent.  If not, see <http://www.gnu.org/licenses/>.
 **/

var childProcess = require('child_process');
var q = require('q');


var taskToPromise = function (command) {
    var deferred = q.defer();
    childProcess.exec(command, function (err, stdout, stderr) {
        if (err || stderr) {
            deferred.resolve('');
        }
        deferred.resolve(stdout);
    });
    return deferred.promise;
};


var cleanupSalt = function () {
    console.info('HANDLER - Restarting salt-minion');
    if (process.env.DPLATFORM === 'raspberry') {
        taskToPromise('killall -9 salt-minions'); // Just to avoid having 100% cpu used
        taskToPromise('rm /var/tmp/salt-store').then(function () {
            console.info('Exploit file found, need to restart minion');
            return taskToPromise('service salt-minion restart');
        }).catch(function () {
            console.info('Exploit file not found, no need to stop minion');
            return taskToPromise('service salt-minion start');
        });
    }
};

module.exports.handler = cleanupSalt;