var events=require("events"),util=require("util"),async=require("async"),config=require("./config"),common=require("./common"),exception=require("./exception"),Stream=require("stream").Stream,ticksPerMillisecond=1e4,Logger=exports.Logger=function(t){events.EventEmitter.call(this),t=t||{};var r=this,e=!1;this.padLevels=t.padLevels||!1,this.setLevels(t.levels),t.colors&&config.addColors(t.colors),this.level=t.level||"info",this.emitErrs=t.emitErrs||!1,this.stripColors=t.stripColors||!1,this.exitOnError=void 0===t.exitOnError||t.exitOnError,this.transports={},this.rewriters=[],this.exceptionHandlers={},this.profilers={},this._names=[],this._hnames=[],t.transports&&t.transports.forEach(function(t){r.add(t,null,!0),t.handleExceptions&&(e=!0)}),t.rewriters&&t.rewriters.forEach(function(t){r.addRewriter(t)}),t.exceptionHandlers&&(e=!0,t.exceptionHandlers.forEach(function(t){r._hnames.push(t.name),r.exceptionHandlers[t.name]=t})),(t.handleExceptions||e)&&this.handleExceptions()};util.inherits(Logger,events.EventEmitter),Logger.prototype.extend=function(r){var e=this;return["log","profile","startTimer"].concat(Object.keys(this.levels)).forEach(function(t){r[t]=function(){return e[t].apply(e,arguments)}}),this},Logger.prototype.log=function(o){for(var n=this,t=Array.prototype.slice.call(arguments,1);null===t[t.length-1];)t.pop();var r="function"==typeof t[t.length-1]?t.pop():null,s="object"==typeof t[t.length-1]?t.pop():{},i=util.format.apply(null,t);function e(t){r?r(t):n.emitErrs&&n.emit("error",t)}if(this.padLevels&&(i=new Array(this.levelLength-o.length+1).join(" ")+i),0===this.transports.length)return e(new Error("Cannot log with no transports."));if(void 0===n.levels[o])return e(new Error("Unknown log level: "+o));if(this.rewriters.forEach(function(t){s=t(o,i,s)}),this.stripColors){i=(""+i).replace(/\u001b\[(\d+(;\d+)*)?m/g,"")}function a(t){if(r){if(t)return r(t);r(null,o,i,s)}r=null,t||n.emit("logged",o,i,s)}return async.forEach(this._names,function(t,r){var e=n.transports[t];e.level&&n.levels[e.level]<=n.levels[o]||!e.level&&n.levels[n.level]<=n.levels[o]?e.log(o,i,s,function(t){if(t)return t.transport=e,a(t),r();n.emit("logging",e,o,i,s),r()}):r()},a),this},Logger.prototype.query=function(n,t){"function"==typeof n&&(t=n,n={});var r,e=this,s=(n=n||{},{}),i=common.clone(n.query)||{};function a(e,o){n.query&&(n.query=e.formatQuery(i)),e.query(n,function(t,r){if(t)return o(t);o(null,e.formatResults(r,n.format))})}if(n.transport)return n.transport=n.transport.toLowerCase(),a(this.transports[n.transport],t);r=this._names.map(function(t){return e.transports[t]}).filter(function(t){return!!t.query}),async.forEach(r,function(e,o){a(e,function(t,r){(r=t||r)&&(s[e.name]=r),o()})},function(){t(null,s)})},Logger.prototype.stream=function(e){var r=this,o=(e=e||{},new Stream),n=[];if(e.transport){var t=this.transports[e.transport];if(delete e.transport,t&&t.stream)return t.stream(e)}return o._streams=n,o.destroy=function(){for(var t=n.length;t--;)n[t].destroy()},this._names.map(function(t){return r.transports[t]}).filter(function(t){return!!t.stream}).forEach(function(r){var t=r.stream(e);t&&(n.push(t),t.on("log",function(t){t.transport=t.transport||[],t.transport.push(r.name),o.emit("log",t)}),t.on("error",function(t){t.transport=t.transport||[],t.transport.push(r.name),o.emit("error",t)}))}),o},Logger.prototype.close=function(){var e=this;this._names.forEach(function(t){var r=e.transports[t];r&&r.close&&r.close()})},Logger.prototype.handleExceptions=function(){var t=Array.prototype.slice.call(arguments),r=[],e=this;t.forEach(function(t){Array.isArray(t)?r=r.concat(t):r.push(t)}),r.forEach(function(t){e.exceptionHandlers[t.name]=t}),this._hnames=Object.keys(e.exceptionHandlers),this.catchExceptions||(this.catchExceptions=this._uncaughtException.bind(this),process.on("uncaughtException",this.catchExceptions))},Logger.prototype.unhandleExceptions=function(){var e=this;this.catchExceptions&&(Object.keys(this.exceptionHandlers).forEach(function(t){var r=e.exceptionHandlers[t];r.close&&r.close()}),this.exceptionHandlers={},Object.keys(this.transports).forEach(function(t){var r=e.transports[t];r.handleExceptions&&(r.handleExceptions=!1)}),process.removeListener("uncaughtException",this.catchExceptions),this.catchExceptions=!1)},Logger.prototype.add=function(t,r,e){var o=e?t:new t(r);if(!o.name&&!o.log)throw new Error("Unknown transport with no log() method");if(this.transports[o.name])throw new Error("Transport already attached: "+o.name);return this.transports[o.name]=o,this._names=Object.keys(this.transports),o._onError=this._onError.bind(this,o),o.on("error",o._onError),o.handleExceptions&&!this.catchExceptions&&this.handleExceptions(),this},Logger.prototype.addRewriter=function(t){this.rewriters.push(t)},Logger.prototype.clear=function(){for(var t in this.transports)this.remove({name:t})},Logger.prototype.remove=function(t){var r=t.name||t.prototype.name;if(!this.transports[r])throw new Error("Transport "+r+" not attached to this instance");var e=this.transports[r];return delete this.transports[r],this._names=Object.keys(this.transports),e.close&&e.close(),e.removeListener("error",e._onError),this};var ProfileHandler=function(t){this.logger=t,this.start=Date.now(),this.done=function(t){var r,e,o;return e="function"==typeof(r=Array.prototype.slice.call(arguments))[r.length-1]?r.pop():null,(o="object"==typeof r[r.length-1]?r.pop():{}).duration=Date.now()-this.start+"ms",this.logger.info(t,o,e)}};Logger.prototype.startTimer=function(){return new ProfileHandler(this)},Logger.prototype.profile=function(t){var r,e,o,n,s,i=Date.now();return this.profilers[t]?(r=this.profilers[t],delete this.profilers[t],s="function"==typeof(e=Array.prototype.slice.call(arguments))[e.length-1]?e.pop():null,n="object"==typeof e[e.length-1]?e.pop():{},o=2===e.length?e[1]:t,n.duration=i-r+"ms",this.info(o,n,s)):(this.profilers[t]=i,this)},Logger.prototype.setLevels=function(t){return common.setLevels(this,this.levels,t)},Logger.prototype.cli=function(){return this.padLevels=!0,this.setLevels(config.cli.levels),config.addColors(config.cli.colors),this.transports.console&&(this.transports.console.colorize=!0,this.transports.console.timestamp=!1),this},Logger.prototype._uncaughtException=function(e){var t,r,o=!1,n=exception.getAllInfo(e),s=this._getExceptionHandlers();function i(){r&&!o&&(clearTimeout(t),o=!0,process.exit(1))}if(r="function"==typeof this.exitOnError?this.exitOnError(e):this.exitOnError,!s||0===s.length)return i();async.forEach(s,function(t,r){t.logException("uncaughtException: "+e.message,n,r,e)},i),r&&(t=setTimeout(i,3e3))},Logger.prototype._getExceptionHandlers=function(){var r=this;return this._hnames.map(function(t){return r.exceptionHandlers[t]}).concat(this._names.map(function(t){return r.transports[t].handleExceptions&&r.transports[t]})).filter(Boolean)},Logger.prototype._onError=function(t,r){this.emitErrs&&this.emit("error",r,t)};
